package ssw.mj;

import java.io.FileReader;
import java.io.IOException;
 
/**
 * <code>Compiler</code> is the driver for the MicroJava-Compiler.
 * 
 * Execute<br>
 * <code>java ssw.mj.Compiler &lt;<i>MJ-Source-Filename</i>&gt;</code><br>
 * to start compililation.
 */
public class Compiler {

	public static void main(String[] args) {
		// --- get the filename
		if (args.length < 1) { 
			System.out.println("usage: java Compiler filename.mic"); 
			return;
		}
		String filename = args[0];
		
		try {
			System.out.println("-----------------------------------");
			Scanner.init(new FileReader(filename));
			System.out.println("Parsing file " + filename + "\n");
			Parser.parse();
			System.out.println("OK, no errors!");
		} catch (IOException ioe) {
			System.out.println("File " + filename + " not found.");
		} catch (Error e) {
			// Panic Mode terminates parsing by throwing an Error
			if (e.getMessage().startsWith("PANIC MODE"))
				System.out.println(e.getMessage());
		}
	}
}
