package ssw.mj;

import java.io.PrintWriter;
import java.util.BitSet;

/**
 * The parser for the MicroJava Compiler.
 */
public class Parser {

	private static final int
		none       = Token.none,
		ident      = Token.ident,
		number     = Token.number,
		charConst  = Token.charConst,
		plus       = Token.plus,
		minus      = Token.minus,
		times      = Token.times,
		slash      = Token.slash,
		rem        = Token.rem,
		eql        = Token.eql,
		neq        = Token.neq,
		gtr        = Token.gtr,
		geq        = Token.geq,
		less       = Token.less,
		leq        = Token.leq,
		and        = Token.and,
		or         = Token.or,
		assign     = Token.assign,
		pplus      = Token.pplus,
		mminus     = Token.mminus,
		semicolon  = Token.semicolon,
		comma      = Token.comma,
		period     = Token.period,
		lpar       = Token.lpar,
		rpar       = Token.rpar,
		lbrack     = Token.lbrack,
		rbrack     = Token.rbrack,
		lbrace     = Token.lbrace,
		rbrace     = Token.rbrace,
		classKW    = Token.classKW,
		continueKW = Token.continueKW,
		doKW       = Token.doKW,
		elseKW     = Token.elseKW,
		finalKW    = Token.finalKW,
		ifKW       = Token.ifKW,
		newKW      = Token.newKW,
		printKW    = Token.printKW,
		readKW     = Token.readKW,
		returnKW   = Token.returnKW,
		voidKW     = Token.voidKW,
		whileKW    = Token.whileKW,
		eof        = Token.eof;
		
	private static final String[] names = Token.names;

	private static PrintWriter out;

	/** Last recognized token; */
	private static Token t;
  
	/** Lookahead token (not recognized).) */
	private static Token la;
  
	/** Shortcut to kind attribute of lookahead token (la). */
	private static int sym;

	/** Reads ahead one symbol. */
	private static void scan () {

	}
	
	/** Verifies symbol and reads ahead. */
	private static void check (int expected) {

	}

	public static void synError (String msg) {
		if (out != null)
			out.println("-- line " + la.line + ", col " + la.col + ": " + msg);
		throw new Error("PANIC MODE: exit at first error");
	}

	/** Program = "class" ident { ConstDecl | VarDecl | ClassDecl } 
	 *			  "{" { MethodDecl } "}" . */
	private static void Program () {

	}
	
	/* ----- add further parsing routines here ----- */
		
	/** Starts the analysis. 
	 *	Output is written to System.out.
	 */
	public static void parse () { parse(new PrintWriter(System.out, true)); }
	
	/** Starts the analysis.
	 *	Output is written the <code>PrintWriter output</code>
	 */
	public static void parse (PrintWriter output) {
		out = output;
		
		/*----- put additional parser start-up code here -----*/
	}
}
